/* $Id: main.c,v 0.10 1997/08/28 14:42:26 yoichi v0_70 $
 *
 * dhcpcd - DHCP client daemon -
 * Copyright (C) 1996 - 1997 Yoichi Hariguchi <yoichi@fore.com>
 *
 * dhcpcd is an RFC2131 and RFC1541 compliant DHCP client daemon.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * EC: This is very different from the original Linux file.  I have vastly
 * stripped down and simplified the main program in order to get it working.
 * Bells and whistles might be added later.
 *
 * Everett Chong
 * echong@my-deja.com
 */

/* #include <sys/types.h> */
#include "multinet_root:[multinet.include.sys]types.h"
#include "multinet_root:[multinet.include.sys]socket.h"
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <fcntl.h>
#include <unistd.h>
#if 0
#include <net/if.h>
#include <arpa/inet.h>
#endif
#include "multinet_root:[multinet.include.net]if.h"
#include "multinet_root:[multinet.include.arpa]inet.h"
#include "if.h"
#include "dhcp.h"
#include "signal-handler.h"
#include "error-handler.h"
#include "daemon.h"
#include "client.h"
#include "memory.h"

#define DEFAULT_IF	"se0"
#define DEFAULT_VMSDEV	"EWA0"

#define   STRLNG   256

char *CommandFile = NULL;		/* invoked command file name when dhcpcd
								 * succeeds in getting an IP address
								 */
int	  BeRFC1541 = 0;			/* default is InternetDraft mode */
char *Hostname = NULL;			/* hostname in the DHCP msg for xmit */
char      VMSdevice[STRLNG];               /* device name for VMS interface */

static char VersionStr[] = "rrdhcpcd 1.03\n";

void	usage();


int
main(argc, argv)
int argc;
char *argv[];
{
	char  ifname[10];			/* interface name */
	char  pidfile[128];			/* file name in which pid is stored */
	char *clientId = NULL;		/* ptr to client identifier user specified */
	int   killFlag = 0;			/* if 1: kill the running proc and exit */

	DebugFlag = 0;				/* default is NON debug mode */
	srand((u_int)time(NULL));
	signalSetup();
	classIDsetup(NULL);			/* setup default class identifier */

	if ( *++argv ) {
		strncpy(ifname, *argv, sizeof(ifname));
                if   ( *++argv )
                   { strcpy(VMSdevice, *argv); }
                 else
                   { strcpy(VMSdevice, DEFAULT_VMSDEV); }
	} else {
		strncpy(ifname, DEFAULT_IF, sizeof(ifname));
                strcpy(VMSdevice, DEFAULT_VMSDEV);
	}
	ifReset(ifname);			/* reset interface, 'Ifbuf' */
	clientIDsetup(clientId, ifname);
	dhcpMsgInit(ifname);
	dhcpClient();
        return 0;
}

void
usage()
{
	fflush(stdout);
#if 0
	fputs("Usage: dhcpcd [-c filename] [-d] [-i classIdentifier] [-I clientIdentifier] [-k] [-l leasetime] [ifname]\n",
		  stderr);
#endif
	fputs("Usage: dhcpc Multinet_interface VMS_ether_device\n",
		  stderr);
	fflush(NULL);
	exit(1);
}

